<template>
    <div>
        <SearchForm :states="states" :textSearch="textSearch" :modeView="modeView" @search="search" @fetchAll="fetchAll" />
        <section class="app-search" id="search-result-content">
            <div class="container">
                <div class="row justify-content-md-center">
                    <div class="col-md-12" :class="{ 'col-lg-9' : modeView == 'search' }">
                        <h2 class="text-center">{{ $t(title) }}</h2>
                        <SearchFilters
                            :filterOptions="filterOptions"
                            :orderOptions="orderOptions"
                            @filter="filter"
                            @order="order"
                            @resetSearch="resetSearch"
                        />
                        
                        <div class="community-posts-wrapper">
                            <!-- <DocumentList v-if="modeView == 'search'" :documents="displayedDocuments" /> -->
                            <DocumentCardList :documents="displayedDocuments" />
                            <!-- /.community-post -->

                            <div v-if="displayedDocuments.length == 0" class="community-post style-two row">
                                <div class="post-content col-sm-12 text-center">
                                    <div class="entry-content">
                                        <strong>{{ $t("messages.no_results") }}</strong>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- /.community-posts-wrapper -->

                        <DocumentPaginator 
                            :currentPage="currentPage"
                            :grandTotal="filteredDocuments.length"
                            :itemsPerPage="itemsPerPage"
                            :modeView="modeView"
                            :pages="pages"
                            :startPage="startPage"
                            :totalPages="totalPages"
                            :totalShowed="displayedDocuments.length"
                            :visiblePages="visiblePages"
                            @changePage="changePage" 
                        />
                        <!-- /.pagination-wrapper -->
                    </div>
                </div>
                <div v-if="modeView !== 'all'" class="text-center">
                    <br />
                    <p><a v-on:click.prevent="fetchAll()" href="#" class="btn btn-red wide">{{ $t("actions.see_all_documents") }} <i class="fas fa-arrow-right"></i></a></p>
                </div>
            </div>
            <div v-if="modeView === 'recent'">
                <AboutUsBlock :aboutUsUrl="aboutUsUrl" />
            </div>
        </section>
    </div>
</template>
<script>
import axios from 'axios';
import SearchForm from './SearchForm.vue';
import SearchFilters from './SearchFilters.vue';
import DocumentCardList from './DocumentCardList.vue';
import DocumentList from './DocumentList.vue';
import DocumentPaginator from './DocumentPaginator.vue';
import AboutUsBlock from './AboutUsBlock.vue';

axios.defaults.headers.common = {
    'X-Requested-With': 'XMLHttpRequest',
    'X-CSRF-TOKEN' : document.querySelector('meta[name="csrf-token"]').getAttribute('content')
};
export default {
	name: 'SearchContainer',
	props: ['searchUrl', 'latestUrl', 'allDocumentsUrl', 'isPost', 'defaultTextSearch', 'defaultCategoryId', 'defaultStateId', 'locale', 'aboutUsUrl', 'updateSearchUrl'],
	components: {
        SearchForm, SearchFilters, DocumentList, DocumentCardList, DocumentPaginator, AboutUsBlock
	},
	data() {
		return {
            categories: [],
            languages: [],
            states: [],
            sectors: [],
            documents: [],
            filteredDocuments: [],
            filterOptions: {
                languages: [],
                categories: [],
                sectors: [],
                states: [],
            },
            filterData: {},
            orderBy: '',
            orderWay: '',
            textSearch: '',
            categoryId: '',
            stateId: '',
            modeView: 'recent',
            pages: [],
            totalPages: 0,
            currentPage: 0,
            visiblePages: 4,
            itemsPerPage: 6
		};
	},
	mounted() {
        if (this.isPost === 'true') {
            if (typeof this.defaultTextSearch !== 'undefined' && this.defaultTextSearch !== '') {
                this.textSearch = this.defaultTextSearch;
            }

            if(typeof this.defaultCategoryId !== 'undefined' && this.defaultCategoryId !== '') {
                this.categoryId = this.defaultCategoryId;
            }

            if(typeof this.defaultStatedId !== 'undefined' && this.defaultStatedId !== '') {
                this.stateId = this.defaultStatedId;
            }

            this.search(this.textSearch, this.categoryId, this.stateId);   
        }
        else {
            this.fetchLatest();
        }

        axios.get('/categories')
            .then(response => this.categories = response.data);

        axios.get('/languages')
            .then(response => this.languages = response.data);

        axios.get('/sectors')
            .then(response => this.sectors = response.data);

        axios.get('/states')
            .then(response => this.states = response.data);
	},
	methods: {
        goto(targetName) {
            let target = document.getElementById(targetName);
            let top = target.offsetTop;
            window.scrollTo({
                top: top,
                behavior: 'smooth'
            });
        },
        fetchLatest() {
            let customData = Object.assign({}, this.filterData);

            if (this.orderBy !== '' && this.orderWay !== '') {
                customData['order'] = this.orderBy;
                customData['way'] = this.orderWay;
            }
            axios({
                method: 'post',
                url: this.latestUrl,
                data: customData
            })
            .then(response => (this.documents = response.data));
        },
        updateSearch() {
            let customData = Object.assign({}, this.filterData);
            customData.text_search = this.textSearch;

            axios({
                method: 'post',
                url: this.updateSearchUrl,
                data: customData
            });
        },
        fetchAll() {
            this.modeView = 'all';

            axios({
                method: 'post',
                url: this.allDocumentsUrl,
            })
            .then(response => {
                this.currentPage = 1;
                this.documents = response.data;
                this.goto('search-result-content');
            });
        },
        filter(filterOptions) {
            this.filterOptions = filterOptions;

            this.filterData = Object.keys(this.filterOptions).reduce((acc, key) => {
                const options = this.filterOptions[key].filter(option => option.checked).map(option => option.id);
                if (options.length > 0) {
                    acc[key] = options;
                }
                return acc;
            }, {});

            this.currentPage = 1;

            if (this.modeView === 'recent') {
                this.fetchLatest();
            }
            else {
                this.filteredDocuments = this.getDocuments();
            }

            this.updateSearch();
        },
        order(criteria, way) {
            this.orderBy = criteria;
            this.orderWay = way;
            this.currentPage = 1;

            if (this.modeView === 'recent') {
                this.fetchLatest();
            }
            else {
                this.filteredDocuments = this.getDocuments();
            }
        },
		search(text, categoryId, stateId) {
            let gotoFn = this.goto;
            this.textSearch = text;
            let customData = {
                text_search: this.textSearch
            };

            this.categoryId = categoryId;
            this.stateId = stateId;
            this.resetFilters();

            if (this.categoryId !== '') {
                customData['category_id'] = this.categoryId;
            }

            if (this.stateId !== '') {
                customData['state_id'] = this.stateId;
            }

            this.modeView =  (this.textSearch !== '' || this.categoryId !== '' || this.stateId !== '') ? 'search' : 'all';
            axios({
                method: 'post',
                url: this.searchUrl,
                data: customData
            })
            .then(response => {
                this.currentPage = 1;
                this.documents = response.data;
                gotoFn('search-result-content');
            });
        },
        resetFilters() {
            this.orderBy = '';
            this.orderWay = '';

            this.filterData = {};

            this.filterOptions.languages = this.languages.map(item => {
                return {
                    id: item.id,
                    name: item.name,
                    icon: item.abbreviation,
                    checked: false
                }
            });
            this.filterOptions.categories = this.categories.map(item => {
                return {
                    id: item.id,
                    name: item.name,
                    color: item.color,
                    checked: false,
                    description: item.description,
                }
            });
            this.filterOptions.sectors = this.sectors.map(item => {
                return {
                    id: item.id,
                    name: item.name,
                    checked: false
                }
            });
            this.filterOptions.states = this.states.map(item => {
                return {
                    id: item.id,
                    name: item.name,
                    checked: false
                }
            });
        },
        resetSearch() {
            this.resetFilters();
            this.currentPage = 1;
            if (this.modeView === 'recent') {
                this.fetchLatest();
            }
            else {
                this.filteredDocuments = this.documents;
            }
        },
        getDocuments() {
            let docs = this.documents.slice();
            
            if (this.modeView === 'recent') {
                return docs;
            }

            if (this.orderBy === 'date') {
                docs = docs.sort((a, b) => (b.publication_date > a.publication_date ? -1 : 1));
            }
            else if (this.orderBy === 'title') {
                docs = docs.sort((a, b) => (b.title > a.title ? -1 : 1));
            }

            if (this.orderBy !== '' && this.orderWay === 'desc') {
                docs = docs.reverse();
            }

            if (Object.keys(this.filterData).length > 0) {
                const fields = {
                    sectors: 'sectors',
                    categories: 'category_id',
                    languages: 'language_id',
                    states: 'states',
                };

                docs = docs.filter(doc => {
                    return Object.keys(this.filterData).every(key => {
                        const field = fields[key];
                        if (Array.isArray(doc[field]) === true) {
                            return doc[field].some(item => this.filterData[key].includes(item.id));
                        }
                        else {
                            return this.filterData[key].includes(doc[field]);
                        }
                    });
                })
            }
            
            return docs;
        },
        setPages() {
            if (this.modeView !== 'recent' && this.filteredDocuments.length > this.itemsPerPage) {
                this.totalPages = Math.ceil(this.filteredDocuments.length / this.itemsPerPage);
                let end = Math.min(this.startPage + this.visiblePages - 1, this.totalPages);
                this.pages = [];
                for(let i = this.startPage; i <= end; i++) {
                    this.pages.push({ name: i, disabled: i == this.currentPage });
                }
            }
        },
        changePage(currentPage) {
            if (this.currentPage !== currentPage) {
                this.currentPage = currentPage;
            }
        }
	},
	computed: {
        displayedDocuments() {
            let docs = this.filteredDocuments.slice();
            if (this.modeView !== 'recent') {
                let start = (this.currentPage - 1) * this.itemsPerPage;
                let end = start + this.itemsPerPage;
                docs = docs.slice(start, end);
            }
            return docs;
        },
        startPage() {
            return (Math.floor((this.currentPage - 1) / this.visiblePages) * this.visiblePages) + 1;
        },
        title() {
            const options = {
                search: "titles.search_results",
                recent: "titles.latest_documents",
                all: "titles.all_documents",
            }

            return options[this.modeView];
        },
        orderOptions() {
            return [
                {
                    id : 1,
                    name: this.$t("options.latest"), 
                    criteria: 'date',
                    way: 'desc',
                },
                {
                    id : 2,
                    name: this.$t("options.oldest"), 
                    criteria: 'date',
                    way: 'asc',
                },
                {
                    id : 3,
                    name: 'A > Z', 
                    criteria: 'title',
                    way: 'asc',
                },
                {
                    id : 4,
                    name: 'Z > A', 
                    criteria: 'title',
                    way: 'desc',
                },
            ]
        }
	},
	watch: {
        documents() {
            this.filteredDocuments = this.getDocuments();
        },
        filteredDocuments() {
            this.currentPage = 1;
            this.setPages();
        },
        startPage() {
            this.setPages();
        },
        languages() {
            this.filterOptions.languages = this.languages.map(item => {
                return {
                    id: item.id,
                    name: item.name,
                    icon: item.abbreviation,
                    checked: false
                }
            });
        },
        categories() {
            this.filterOptions.categories = this.categories.map(item => {
                return {
                    id: item.id,
                    name: item.name,
                    color: item.color,
                    checked: false,
                    description: item.description,
                }
            });
        },
        sectors() {
            this.filterOptions.sectors = this.sectors.map(item => {
                return {
                    id: item.id,
                    name: item.name,
                    checked: false
                }
            });
        },
        states() {
            this.filterOptions.states = this.states.map(item => {
                return {
                    id: item.id,
                    name: item.name,
                    checked: false
                }
            });
        }
	}
}
</script>